diff --git a/src/fl_file_dir.cxx b/src/fl_file_dir.cxx
index 6ee7bf3..fe46be3 100644
--- a/src/fl_file_dir.cxx
+++ b/src/fl_file_dir.cxx
@@ -132,9 +132,16 @@ fl_file_chooser(const char *message,	// I - Message in titlebar
   fc->ok_label(current_label);
   fc->show();
 
+  // deactivate Fl::grab(), because it is incompatible with modal windows
+  Fl_Window* g = Fl::grab();
+  if (g) Fl::grab(0);
+
   while (fc->shown())
     Fl::wait();
 
+  if (g) // regrab the previous popup menu, if there was one
+    Fl::grab(g);
+
   if (fc->value() && relative) {
     fl_filename_relative(retname, sizeof(retname), fc->value());
 
